#include <imsls.h>
#include <stdio.h>
extern FILE* imsls_fopen(char* filename, char* mode);
extern void imsls_fclose(FILE* file);

int main()
{
   FILE *file;
   char *filename = "NB_Classifier_Ex2.txt";
   int i, j;
   int n_patterns    =150; /* 150 training patterns            */
   int n_cont4       =4;   /* four continuous input attributes */
   int n_cont2       =2;   /* two continuous input attributes  */
   int n_classes     =3;   /* three classification categories  */
   int n_classifiers =0;   /* number of classifiers            */
   int classification[150], *predictedClass;
   int classErrors[8];
   float cont4[4*150], cont2[2*150] ;
   float *irisData;       /* Fishers Iris Data */
   char *classLabel[3] = {"Setosa     ", "Versicolour", "Virginica  "};
   Imsls_f_nb_classifier *nb_classifier4, *nb_classifier2;
   irisData = imsls_f_data_sets(3,0);

   /* setup the required input arrays from the data matrix */
   for(i=0; i<n_patterns; i++){
      classification[i] = (int) irisData[i*5]-1;
      for(j=1; j<=n_cont4; j++) {
         cont4[i*n_cont4+j-1] = irisData[i*5+j];
         if(j<3) cont2[i*n_cont2+j-1] = irisData[i*5+j];
      }
   }
   printf("Opening file %s\n\n", filename);
   file = imsls_fopen(filename, "r");
   fscanf(file, "%d", &n_classifiers);

   nb_classifier4 = imsls_f_nb_classifier_read(" ", IMSLS_PRINT, 
      IMSLS_FILE, file, 0);
   predictedClass = imsls_f_naive_bayes_classification(nb_classifier4, 
      n_patterns, IMSLS_CONTINUOUS, cont4, 0);
   for(i=0; i<6; i++) classErrors[i] = 0;
   for(i=0; i<n_patterns; i++){
      switch (classification[i])
      {
      case 0: 
         classErrors[1]++;
         if(classification[i] != predictedClass[i]) 
            classErrors[0]++; 
         break;
      case 1:
         classErrors[3]++;
         if(classification[i] != predictedClass[i]) 
            classErrors[2]++;
         break;
      case 2:
         classErrors[5]++;
         if(classification[i] != predictedClass[i]) 
            classErrors[4]++;
         break;
      }
   }
   classErrors[6] = classErrors[0]+classErrors[2]+classErrors[4];
   classErrors[7] = classErrors[1]+classErrors[3]+classErrors[5];
   printf("     Iris Classification Error Rates\n");
   printf("----------------------------------------------\n");
   printf("   Setosa  Versicolour  Virginica   |   TOTAL\n");
   printf("    %d/%d      %d/%d         %d/%d     |   %d/%d\n", 
      classErrors[0], classErrors[1],
      classErrors[2], classErrors[3], classErrors[4], classErrors[5],
      classErrors[6], classErrors[7]);
   printf("----------------------------------------------\n\n");
   imsls_free(predictedClass);
   nb_classifier2 = imsls_f_nb_classifier_read(" ", IMSLS_PRINT,
      IMSLS_FILE, file, 0);
   predictedClass = imsls_f_naive_bayes_classification(nb_classifier2, 
      n_patterns, 
      IMSLS_CONTINUOUS, cont2, 0);
   for(i=0; i<6; i++) classErrors[i] = 0;
   for(i=0; i<n_patterns; i++){
      switch (classification[i])
      {
      case 0: 
         classErrors[1]++;
         if(classification[i] != predictedClass[i]) 
            classErrors[0]++;
         break;
      case 1:
         classErrors[3]++;
         if(classification[i] != predictedClass[i]) 
            classErrors[2]++;
         break;
      case 2:
         classErrors[5]++;
         if(classification[i] != predictedClass[i]) 
            classErrors[4]++;
         break;
      }
   }
   classErrors[6] = classErrors[0]+classErrors[2]+classErrors[4];
   classErrors[7] = classErrors[1]+classErrors[3]+classErrors[5];
   printf("     Iris Classification Error Rates\n");
   printf("----------------------------------------------\n");
   printf("   Setosa  Versicolour  Virginica   |   TOTAL\n");
   printf("    %d/%d      %d/%d         %d/%d     |   %d/%d\n", 
      classErrors[0], classErrors[1],
      classErrors[2], classErrors[3], classErrors[4], classErrors[5],
      classErrors[6], classErrors[7]);
   printf("----------------------------------------------\n\n");
   imsls_free(predictedClass);
   printf("Closing Classifier File.\n");
   imsls_fclose(file);
}
